/* #################################################################### */
/* ##								     ##	*/									
/* ##	                PROGETTO "HOTEL ONLINE "          	     ##	*/									
/* ##		       Gennaio 2001 (Giugno 2001)		     ##	*/									
/* ##								     ##	*/									
/* ##			SERVER ENTE TURISTICO	        	     ##	*/									
/* ##								     ##	*/									
/* ##								     ##	*/									
/* ##	   Laura Esposito(565379) & Vincenza Zermo(563237)	     ##	*/									
/* ##								     ##	*/									
/* #################################################################### */




#include "lib.h"

int N_Alberghi;
int Num_sock[MAX_SOCK];




// =================================== Procedura NuovoClient ===================================================

/* Viene gestita la tipologia di client connesso (albergo o turista)e le scelte progettuali */ 

int NuovoClient(int asock) {
 
  char In[MES];
  char Out[MES];
  char aus1[MES]; 
  char aus2[MES]; 
  int err; 
  int codAlb;
  struct albergo *primo_Alb;
  int lung;
  struct sockaddr_in cliente;
  
  /* controlla il tipo di cliente connesso */
  bzero(In,sizeof(In));
  if ( (err=read(asock,&In,sizeof(In)))<0) {  
    fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
    sprintf(Out,"NACK_GC1");  
    Send(asock,Out);
    return -1;
  }
  if ( err==0 ) { 
    fprintf(stderr,"Connessione Chiusa dal Client!!!\n");
    return -2;
   }
   
  fprintf(stderr,"Ricevuto Messaggio...\n");

  if ( !strcmp(In,"\0") ) {
    sprintf(Out,"NACK_GC2");  
    Send(asock,Out);
    Errore("Errore: Lettura dei dati\n",-2,sys_errlist[errno]);
    
  }
  /* Estrae il codice */
  bzero(aus1,sizeof(aus1)); 
  estrai(In,aus1);
  
  /* controlla lo stato dell'albergo per eventualmente aprirlo*/
  if ( !strcmp(aus1,"AP") || !strcmp(aus1,"CH") ) {
    bzero(aus2,sizeof aus2);
    estrai(In,aus2);
    if ( !strcmp(aus2,"") ) {
      sprintf(Out,"NACK_GC3");  
      Send(asock,Out);
      Errore("Errore: Stringa Codice Vuota\n",-3,sys_errlist[errno]);
      
    }
    codAlb=atoi(&aus2);
    fprintf(stderr,"Codice Albergo: %d\n",codAlb);
    if ( codAlb<=0 ) {
      sprintf(Out,"NACK_GC4");  
      Send(asock,Out);
      Errore("Errore: Codice Errato",-4,sys_errlist[errno]);
      
    }
    /* cerca il puntatore all'albergo */
    primo_Alb = (struct albergo *)ricercaAl(codAlb);
    if ( primo_Alb==NULL ) {
      sprintf(Out,"NACK_GC5");  
      Send(asock,Out);
      Errore("Errore: Albergo non trovato",-5,sys_errlist[errno]);
      
    }
    fprintf(stderr,"Modifico lo stato dell'albergo %s: %c\n",primo_Alb->nome,primo_Alb->stato);

    /* apre o chiude l'albergo */
    if ( !strcmp(aus1,"AP") ) {    
      primo_Alb->stato=0x41; /* aperto */
    } else {
      primo_Alb->stato=0x43; /* chiuso */
    }

    fprintf(stderr,"Stato dell'albergo %s: %c\n\n",primo_Alb->nome,primo_Alb->stato);
    sprintf(Out,"ACK_%d",codAlb);  
    Send(asock,Out);

  } else /* spedisce la lista degli alberghi */
      if ( !strcmp(aus1,"LA") ) {
        primo_Alb=head;
        while ( primo_Alb!=NULL ) {
           /* se l'albergo e' aperto spedisce i dati */
          if ( primo_Alb->stato==0x41 ) {
	     bzero(Out,sizeof Out);
	     sprintf(Out,"AL_%s_%d_%s_%u",primo_Alb->nome,primo_Alb->posti,primo_Alb->indIP,primo_Alb->porta);
	     Send(asock,Out);
            }
          primo_Alb = primo_Alb->next;
         }
        sprintf(Out,"ACK");  
        Send(asock,Out);

      } else {
               sprintf(Out,"NACK_6");  
               Send(asock,Out);
               Errore("Errore: Codice Messaggio Errato",-7,sys_errlist[errno]);
    
               }   

  return 0;
}





// =================================== Procedura Client ===================================================


/* Inizializza la connessione con il client individuando la porta e la socket dedicate per */
/* la comunicazione,memorizzando i dati delle strutture dati che l'ente turistico deve gestire */  
 
 
int Client(int asock) {

  char In[MES]; 
  char Out[MES];
  char nome[NOME]; 
  char aus[MES]; 
  int codAlb;
  int num;
  char ind_Alb[IND_IP]; 
  int porta_Alb; 
  struct albergo *hotel;
  struct albergo *hotel_aus;
  int lung;
  struct sockaddr_in cliente;
  struct sockaddr_in *struc_aus;
  
  
  N_Alberghi=1;
  lung=sizeof cliente; 
  struc_aus=&cliente;
  if (getpeername(asock,(struct sockaddr *) &cliente,&lung)<0) {
    fprintf(stderr,"Il client non fornisce Indirizzo IP e porta!!\n");
    return -1;  
  }  
  fprintf(stderr,"Client connesso < IP > [porta]: %s, %d\n",inet_ntoa(cliente.sin_addr),cliente.sin_port);
  /* spedisco il messaggio di richiesta di identificazione del client */
  sprintf(Out,"ID_%d",N_Alberghi);  
  Send(asock,Out);
  
  bzero(In,sizeof In);
  if (read(asock,&In,sizeof In)<=0) {
    sprintf(Out,"NACK_3");  
    Send(asock,Out);
    fprintf(stderr,"Errore: Read()!!\n");
    return -3;
  }
  fprintf(stderr,"Ricevuto Messaggio...\n");

  /* estrae il codice */
  bzero(aus,sizeof aus);
  estrai(In,aus);
  if ( strcmp(aus,"ID") ) {
    sprintf(Out,"NACK_4");  
    Send(asock,Out);
    fprintf(stderr,"Codice errato\n");
    return -4;
  }

  bzero(aus,sizeof aus);
  estrai(In,aus);
  
  /* connessione di un turista */
  if ( !strcmp(aus,"T") ) {
    fprintf(stderr,"Tipo di client: Turista\n");
    bzero(aus,sizeof aus);
    estrai(In,aus);
    if ( strcmp(aus,"") ) {
      sprintf(Out,"NACK_5");  
      Send(asock,Out);
      fprintf(stderr,"Messaggio del turista errato!!\n");
      return -5;
    }

    fprintf(stderr,"Si e'connesso nuovo turista...\n");
    sprintf(Out,"ACK");  
    Send(asock,Out);

    /*connessione di un albergo */
  } else if ( !strcmp(aus,"A") ) {
    fprintf(stderr,"Tipo di client: Albergo\n");
    bzero(aus,sizeof aus);
    estrai(In,aus);
    if ( !strcmp(aus,"") ) {
      sprintf(Out,"NACK_6");  
      Send(asock,Out);
      fprintf(stderr,"Stringa del codice albergo vuota\n");
      return -6;
 
    }
    /* memorizza il codice dell'albergo */
    codAlb=atoi(aus);
    fprintf(stderr,"Codice Albergo: %d\n",codAlb);
    fprintf(stderr,"Totale degli alberghi connessi: %d\n",N_Alberghi);
    if ( codAlb!=N_Alberghi ) {
      sprintf(Out,"NACK_7");  
      Send(asock,Out);
      fprintf(stderr,"Codice errato\n");
      return -7;
    }
    
    /* memorizza il nome dell'albergo*/
    bzero(nome,sizeof nome);
    estrai(In,&nome);
    fprintf(stderr,"Albergo: %s\n",nome);
    if (!strcmp (&nome,"") ) {
      sprintf(Out,"NACK_8");  
      Send(asock,Out);
      fprintf(stderr,"Stringa del nome dell'albergo vuota\n");
      return -8;
    }
    
    /* memorizza il numero di posti disponibili */
    bzero(aus,sizeof aus);
    estrai(In,aus);
    if ( !strcmp (aus,"") ) {
      sprintf(Out,"NACK_9");  
      Send(asock,Out);
      fprintf(stderr,"Stringa del numero posti vuota\n");
      return -9;
      
    }
    num=atoi(aus);
    fprintf(stderr,"Posti disponibili: %d\n",num);
    if ( num==0 ) {
      sprintf(Out,"NACK_10");  
      Send(asock,Out);
      fprintf(stderr,"Numero dei posti errato\n");
      return -10;
    }
    
    /* memorizza l'indirizzo IP del server albergo */
    bzero(ind_Alb,sizeof ind_Alb);
    strcpy((char *)&ind_Alb,(char *)inet_ntoa(cliente.sin_addr));
    fprintf(stderr,"IP Server Albergo: %s\n",ind_Alb);
    if (!strcmp (&ind_Alb,"") ) {
      sprintf(Out,"NACK_8");  
      Send(asock,Out);
      fprintf(stderr,"Stringa dell'IP albergo vuota\n");
      return -8;

    }
    
    /* memorizza la porta del server albergo */
    bzero(aus,sizeof aus);
    estrai(In,aus);
    if ( !strcmp (aus,"") ) {
      sprintf(Out,"NACK_9");  
      Send(asock,Out);
      fprintf(stderr,"Stringa della porta Server vuota\n");
      return -9;
    }
    porta_Alb=atoi(aus);
    fprintf(stderr,"Porta Server Albergo: %d\n",porta_Alb);
    if ( num==0 ) {
      sprintf(Out,"NACK_10");  
      Send(asock,Out);
      fprintf(stderr,"Porta del server errato\n");
      return -10;
      
    }
    
    /* crea la struttura per la memorizzazione degli alberghi connessi e la riempie*/
    hotel = (struct albergo *)malloc(sizeof(struct albergo));
    if ( hotel==NULL ) {
      sprintf(Out,"NACK_11");  
      Send(asock,Out);
      fprintf(stderr,"Errore: Malloc()\n");
      return -11;
    }
    hotel->codice=N_Alberghi++;
    strcpy((char *)&(hotel->nome),&nome);
    hotel->posti=num;
    hotel->stato=0x43; /* lettera C */
    bzero((hotel->indIP),sizeof (hotel->indIP));
    strcpy((char *)&(hotel->indIP),(char *)&ind_Alb);
    hotel->porta=porta_Alb;
    hotel->next=NULL;
    
    /* inserisce l'albergo nella lista */
    if ( head==NULL ) {
      head=hotel;
    } else {
      hotel_aus = head;
      while ( hotel_aus->next!=NULL ) {
	hotel_aus=hotel_aus->next;
      }
      hotel_aus->next=hotel;
    }
    fprintf(stderr,"Inserito l'albergo %s in lista!!\n\n",nome);
    sprintf(Out,"ACK_%d",codAlb);  
    Send(asock,Out);

    /* memorizza nella struttura la corrispondenza tra socket e albergo */
    Num_sock[asock]=N_Alberghi-1;

  } else {

    sprintf(Out,"NACK_12");  
    Send(asock,Out);
    fprintf(stderr,"Tipo di client errato\n");
    return -5;
  }

  return 0;
}




// =================================== Procedura gestisci ===================================================

/* Viene gestita la richiesta di connessione di un client sulla socket del server */
/* creando una socket dedicata alla connessione richiesta */


void gestisci(int psock)  {

  fd_set rfds;
  fd_set afds;
  int fd, nfds;
  int asock;
  int lung;
  struct sockaddr_in cliente;
  int codAlb; 
  struct albergo *primo_Alb;
    
  nfds = FOPEN_MAX; 
  FD_ZERO(&afds);
  FD_SET(psock, &afds);
  
  
  /* Inizio della comunicazione */    
  while(1) {
    bcopy ((char*) &afds, (char*) &rfds, sizeof(rfds));   
    fprintf(stderr,"\nIn attesa di input...\n");
    
    if (select(nfds, &rfds, (fd_set*) 0, (fd_set*) 0, (struct timeval*) 0) < 0){
      fprintf(stderr,"Errore: Select() %s\n", sys_errlist[errno]);
      exit(-1);
     }
    /* Attende l'arrivo di una richiesta sul socket*/
    if (FD_ISSET(psock, &rfds)) {
      lung=sizeof(cliente);
      asock = accept(psock, (struct sockaddr*) &cliente, &lung);
      if (asock <0){
        fprintf(stderr,"Errore: Accept() %s\n", sys_errlist[errno]);
	exit(-2);
       }  
	
      fprintf(stderr,"Un nuovo client connesso sulla socket: %d\n", asock);
      
      /* viene attivata e confermata la connessione con il client*/
      if ( Client(asock) ) {
	fprintf(stderr,"Errore: Client non attivato\n");
	close(asock);
	fprintf(stderr,"Socket chiusa!!\n");
       } else {
	/* inserisce la socket del client nell'insieme delle socket su cui attendere per la lettura */
	FD_SET(asock, &afds);
      }
    } 
    
    /* cicla su tutti i possibili file descriptor e controlla
       quali di essi hanno attivato la select */
    for (fd = 0; fd<nfds; ++fd) {
      if (fd != psock && FD_ISSET(fd, &rfds)) {
	
	/* quando viene eliminata la connessione con il client albergo elimina l'albergo dalla lista */
	/* ed elimina la socket dall'insieme della socket su cui rimanere in ascolto */
	if (NuovoClient(fd)!=0) {

	  fprintf(stderr,"Connessione chiusa sulla socket: %d\n\r",fd);
	  close(fd);
          codAlb=Num_sock[fd];
	  Num_sock[fd]=0;

	  if ( codAlb>0 ) {
	    primo_Alb = ricercaAl(codAlb);
	    if ( primo_Alb==NULL ) {
	      fprintf(stderr,"Errore: albergo non trovato\n");
	    } else {
	      eliminaAl(primo_Alb);
	    }
	  }

	  FD_CLR(fd, &afds);  
	}           
      }  
    }
  }   
}






// =================================== Procedura SocketPassiva ===================================================

/* Viene creata la socket che accetta le richieste di connessione da parte dei client turista */
/* e albergo. E' creata in dominio internet e' di tipo bytestream per il protocollo  TCP/IP */



int SocketPassiva(unsigned short porta) {
  
  int sock;
  struct sockaddr_in ind_ente;
  
  /* viene aperta una socket in dominio internet e di tipo bytestream (TCP) */
  sock = socket(PF_INET, SOCK_STREAM, 0);
  if(sock<0){
    printf("Errore: Socket() %s\n",sys_errlist[errno]);
    exit(1);
  }
  /* memorizzo i dati della connessione in una struttura di tipo sockaddr_in */
  ind_ente.sin_family=AF_INET;
  ind_ente.sin_port=htons(porta);
  ind_ente.sin_addr.s_addr=htonl(INADDR_ANY);

  if(bind(sock, (struct sockaddr *)&ind_ente, sizeof(ind_ente)) == -1){
     printf("Errore: Bind() %s\n",sys_errlist[errno]);
     exit(2);
    }
  printf("       [Socket %d <==> porta %d]\n", sock, porta);
  
  /* viene abilitata la socket alla ricezione di richieste di connessione */
  if(listen(sock, 10) == -1) { 
    printf("Errore: Listen() %s\n",sys_errlist[errno]);
    exit(3);
   }
 
  printf("\nEnte Turistico in esecuzione...\n");
  
  return sock;
}






// =================================== MAIN ===================================================



int main(int argc,char *argv[]) 
{
  int psock;
  int porta;
  int i;
  char benvenuto[1024]="\n    BENVENUTO nel Server Ente Turistico\n";

  
  if (argc != 2)
    Errore("USO: >./ente [porta]", -1, NULL);
  porta=atoi(argv[1]);
  if ((porta<1024)||(porta>65535))
    Errore("Porta", porta, "Errore: Porta non valida!");
  
  N_Alberghi=1;
  for (i=0;i<=MAX_SOCK;i++) {
    Num_sock[i]=0;
  }

  printf("%s", benvenuto);
  psock=SocketPassiva(porta);

  gestisci(psock);
  return 0;
}
