/* #################################################################### */
/* ##								     ##	*/									
/* ##	                PROGETTO "HOTEL ONLINE "          	     ##	*/									
/* ##		       Gennaio 2001 (Giugno 2001)		     ##	*/									
/* ##								     ##	*/									
/* ##			   LIBRERIA LIB.H   	        	     ##	*/									
/* ##								     ##	*/									
/* ##								     ##	*/									
/* ##	   Laura Esposito(565379) & Vincenza Zermo(563237)	     ##	*/									
/* ##								     ##	*/									
/* #################################################################### */





#include <signal.h> 
#include <unistd.h> 
#include <stdio.h>  
#include <string.h> 
#include <strings.h>
#include <stdlib.h> 
#include <varargs.h>
#include <stdio.h>
#include <varargs.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>



#define MAX_SOCK FOPEN_MAX
#define Ndisponibili 10
#define MES 200
#define NOME 50
#define IND_IP 40

extern int errno;
extern char *sys_errlist[]; 

struct albergo {
  int codice;
  char nome[30];
  int posti;
  char stato;
  char indIP[40];
  unsigned short int porta;
  struct albergo *next;
};

struct albergo *head = NULL;






// =================================== Procedura Errore ===============================================


/* Gestisce gli errori nella comunicazione.Viene usata dai processi Server e Client */



int Errore (char *prompt, int err, char *errcode)
{
   printf ("%s ", prompt);
   if (err != -1)
    printf ("%i ", err); 
   if ((err != -1) && (errcode != NULL))
     printf (" ");
   if (errcode != NULL)
      printf ("%s", errcode);
      
   printf ("\n");
   exit (1);
}





// =================================== Procedura estrai ==============================================

/* Estrae il primo campo del messaggio passato alla socket Viene usata dai processi Server e Client */


int estrai(char *mes[], char *aus[])
{
  int i;
  char *punt;
  char car;

  punt=(char *)mes;
  strncpy((char *)&car,mes,1);
  i = 0;
  while ( car!=95 && car!=0 && car!=10 ) {
    i++;
    punt++;
    strncpy((char *)&car,punt,1);
  }
  bzero(aus,sizeof aus);
  strncpy(aus,mes,i);
  punt++;
  strcpy((char *)mes,punt);
  return 0;
}




// =================================== Procedura ricercaAl ===================================================

/* Ricerca la struttura albergo attraverso il parametro CodiceAlbergo passatogli e restituisce il puntatore */
/* dell'albergo trovato.Viene usata dal processo Server */



struct albergo* ricercaAl(int codAlb) {

  struct albergo *primo_Alb;

  primo_Alb = head;
  while ( primo_Alb!=NULL && primo_Alb->codice!=codAlb ) 
    primo_Alb=primo_Alb->next;
 
  return primo_Alb;
}




// =================================== Procedura Send ===================================================

/* Viene usata per scrivere il messaggio sulla socket passata come parametro.Viene usata dal processo Server */


int Send(int sock,char *s) {
  int lm;
  
  //fprintf(stderr,"Inviato Messaggio => %s\n",s);
  strcat(s,"\n");
  lm=(int)strlen(s);
  write(sock,s,lm);
  return 0;
}




// =================================== Procedura eliminaAl ===================================================

/* Elimina l'albergo selezionato dalla lista degli alberghi: scandisce la lista se necessario */
/* Viene usata dal processo Server */


int eliminaAl(struct albergo *primo_Alb) {
  struct albergo *prec;

  if ( head==primo_Alb ) {
    head=primo_Alb->next;
  } else {
    prec=head;
    while( prec->next!=primo_Alb && prec!=NULL ) {
      prec=prec->next;
    }
    if ( prec!=NULL ) {
      prec->next=primo_Alb->next;
    }
  }
  free(primo_Alb);
  return 0;
}



// =================================== Procedura eliminaLAlberghi ============================================

/* Elimina la lista degli alberghi che ogni 4 secondi il Server spedice al Client che la richiede */
/* Viene usata dal processo Client */

int eliminaLAlberghi(void) {
  struct albergo *prec;
  struct albergo *succ; 

  prec=head;
  while(prec!=NULL) {
    succ=prec->next;
    free(prec);
    prec=succ;
  }
  head=NULL;

  return 0;
}
